﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace GenericDemos
{
    class Demo3
    {
        //约束版
        void Foo<T>(T obj1, T obj2) where T : IComparable
        {
            int r = obj1.CompareTo(obj2);
        }

        //避免约束：版本1
        void Foo1(IComparable obj1, IComparable obj2)
        {
            int r = obj1.CompareTo(obj2);
        }

        //避免约束：版本2
        void Foo2<T>(T obj1, T obj2)
        {
            int r = Comparer<T>.Default.Compare(obj1, obj2);
            T obj = Activator.CreateInstance<T>();
        }
    }

    
}
