﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace GenericDemos
{
    class TypeDict<T>
    {
        public static int Value1;
        public static int Value2;
    }

    class ConstraintDemo<T> where T : Base, new()
    {
        public static void Foo()
        {
            ConstraintDemo<A> x;
            ConstraintDemo<B> y;
            //ConstraintDemo<C> z; //别人写的不行
            //ConstraintDemo<Base> w; //Base自己也不行
        }
    }

    abstract class Base
    {
        //设为internal，其他人就不能继承这个类
        internal Base() { }
    }

    class A : Base
    {

    }

    class B : Base
    {
    }

    class C //别人写的类
    {
    }
}
